前往小程序,Get更优阅读体验!
立即前往
首页
学习
活动
专区
工具
TVP
发布
社区首页 >专栏 >Prime Path (POJ - 3126 )(BFS)

Prime Path (POJ - 3126 )(BFS)

作者头像
Lokinli
发布2023-03-09 16:40:12
1560
发布2023-03-09 16:40:12
举报
文章被收录于专栏:以终为始以终为始

转载请注明出处:https://blog.csdn.net/Mercury_Lc/article/details/82697622     作者:Mercury_Lc

题目链接

题意:就是给你一个n,让你每次可以改变n的位数上的一个数,每次操作完必须是素数,要求最小次数的改变到达m。

题解:对n每一位都进行判断,找到通过最小操作次数得到m。分别要从个位、十位、百位、千位判断,在个位的时候每次只能是1、3、5、7、9,其他的改变之后都不是素数,十位、百位、千位都从0开始遍历到9,每次只要符合是素数就放到队列中,开个结构体记录步数和当前的数就可以了。

代码语言:javascript
复制
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <queue>
#include <iostream>

using namespace std;
const int maxn = 1e6;
int n,m;
int vis[maxn];
struct node
{
    int data,step;
} w,l;
bool prime(int x)
{
    if(x==1||x==0)
        return 0;
    for(int i = 2; i <= sqrt(x); i ++)
    {
        if(x % i == 0)
            return 0;
    }
    return 1;
}

void bfs()
{
    queue<node>q;
    memset(vis,0,sizeof(vis));
    vis[n] = 1;
    w.data = n;
    w.step = 0;
    q.push(w);
    while(!q.empty())
    {
        w = q.front();
        q.pop();
        if(w.data == m)
        {
            printf("%d\n",w.step);
            return ;
        }
        for(int i = 1; i <= 9; i += 2)  // ge
        {
            int s = w.data / 10 * 10 + i;
            if(!vis[s] && prime(s))
            {
                vis[s] = 1;
                l.data = s;
                l.step = w.step + 1;
                q.push(l);
            }
        }
        for(int i = 0; i <= 9; i++)  // shi
        {
            int s = w.data / 100 * 100 + i * 10 + w.data % 10;
            if(!vis[s] && prime(s))
            {
                vis[s] = 1;
                l.data = s;
                l.step = w.step + 1;
                q.push(l);
            }
        }
        for(int i = 0; i <= 9; i++)  // bai
        {
            int s = w.data / 1000 * 1000 + i * 100 + w.data % 100;
            if(!vis[s] && prime(s))
            {
                vis[s] = 1;
                l.data = s;
                l.step = w.step + 1;
                q.push(l);
            }
        }
        for(int i = 1; i <= 9; i++)  // qian
        {
            int s = i * 1000 + w.data % 1000;
            if(!vis[s] && prime(s))
            {
                vis[s] = 1;
                l.data = s;
                l.step = w.step + 1;
                q.push(l);
            }
        }
    }
    return ;
}
int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d%d",&n,&m);
        bfs();
    }
    return 0;
}

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. — It is a matter of security to change such things every now and then, to keep the enemy in the dark. — But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! — I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. — No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! — I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. — Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. Now, the minister of finance, who had been eavesdropping, intervened. — No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. — Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? — In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 1033 1733 3733 3739 3779 8779 8179 The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased. Input One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros). Output One line for each case, either with a number stating the minimal cost or containing the word Impossible. Sample Input 3 1033 8179 1373 8017 1033 1033 Sample Output 6 7 0

本文参与 腾讯云自媒体同步曝光计划,分享自作者个人站点/博客。
原始发表:2018-09-14,如有侵权请联系 cloudcommunity@tencent.com 删除

本文分享自 作者个人站点/博客 前往查看

如有侵权,请联系 cloudcommunity@tencent.com 删除。

本文参与 腾讯云自媒体同步曝光计划  ,欢迎热爱写作的你一起参与!

评论
登录后参与评论
0 条评论
热度
最新
推荐阅读
领券
问题归档专栏文章快讯文章归档关键词归档开发者手册归档开发者手册 Section 归档